package kartelj.aleksandar.various;

import java.io.Serializable;
import java.util.Comparator;

import org.apache.spark.api.java.function.Function2;

/**
 * Potpuno genericki serijalizabilni komparator 
 * @author nalog
 *
 * @param <T> - tip objekta za koji se komparator primenjuje
 */
public class GenericSerializableComparator<T> implements Comparator<T>,
		Serializable {

	private Function2<T, T, Integer> compFunc;

	public GenericSerializableComparator(Function2<T, T, Integer> compFunc) {
		this.compFunc = compFunc;
	}

	@Override
	public int compare(T o1, T o2){
		try {
			return compFunc.call(o1, o2);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return 0;
	}
}
