package kartelj.aleksandar.various;

import java.util.List;

import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaPairRDD;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;

import scala.Tuple2;

/**
 * http://spark.apache.org/docs/latest/programming-guide.html
 *
 */
public class Treci {
	public static void main(String[] args) {
		SparkConf conf = new SparkConf();
		conf.setAppName("app");
		conf.setMaster("local[*]");

		JavaSparkContext sc = new JavaSparkContext(conf);
		JavaRDD<String> lines = sc.textFile("src/brojevi2.txt");
		// mapiramo u brojeve
		JavaRDD<Integer> numbers = lines.map(x -> Integer.valueOf(x));
		JavaPairRDD<Integer, Integer> numberOnePairs = numbers
				.mapToPair(x -> new Tuple2<>(x, 1));
		// reduceByKey grupise po kljucu a redukuje po vrednosti
		// znaci grupise po prvom elementu uredjeno para a npr. sabira drugi
		// element uredj. para
		JavaPairRDD<Integer, Integer> numberFreq = numberOnePairs.reduceByKey((
				x, y) -> x + y);
		// gnerickom komparatoru prosledjujemo lambda izraz poredjenja dva elementa
		// kolekcije pri cemu je svaki element uredjeni par
		// a kriterijum poredjenja je zasnovan na drugom elementu uredjenog para
		// zato se porede p2._2() i p1._2()
		List<Tuple2<Integer, Integer>> top10 = numberFreq.takeOrdered(10,
				new GenericSerializableComparator<Tuple2<Integer, Integer>>((
						p1, p2) -> p2._2() - p1._2()));
		// uzimamo prvih 100 parova na drajver
		for (Tuple2<Integer, Integer> p : top10)
			System.out.println(p._1() + " (" + p._2() + " pojavljivanja)");
	}
}
